<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <div>

    <v-btn
      v-if="!isAuthenticated"
      @click="login()"
      text>
      Log in
    </v-btn>
    
    <v-menu
      :offset-y="true"
      v-if="isAuthenticated"
    >
      <template v-slot:activator="{ on, attrs }">
        <div
            v-bind="attrs"
            v-on="on"
        >
          <v-avatar
            color="accent"
          >
            <img
              v-if="getProfile.gravatar"
              :src="getProfile.gravatar"
            >
            <span
              v-else 
              class="white--text headline"
            >{{shortname}}</span>
          </v-avatar>
          <v-icon>
            mdi-chevron-down
          </v-icon>
        </div>
      </template>
  
      <v-list dense>
        <v-list-item>
          <v-list-item-content>
            <div class="flag-bfh-ES">{{loggedAs}} <span style="padding-left:0.2em" v-if="loggedAs!=getProfile.preferred_username">({{getProfile.preferred_username}})</span></div>
          </v-list-item-content>
        </v-list-item>
        <v-divider/>
        <v-list-item
          @click="logout()"
        >
          Log out
        </v-list-item>
      </v-list>
  
    </v-menu>
    
  </div>

</template>


<script>
import { mapGetters } from "vuex";
import { AUTH_REQUEST } from "../store/actions/auth";

export default {
  name: 'App',
  
  computed: {
    ...mapGetters(["isAuthenticated", "authStatus", "getProfile"]),
    loading: function() {
      return this.authStatus === "loading" && !this.isAuthenticated;
    },
    shortname: function() {
      if(this.getProfile.given_name && this.getProfile.family_name)
        return this.getProfile.given_name.toUpperCase().substring(0,1) + this.getProfile.family_name.toUpperCase().substring(0,1);
      else if(this.getProfile.name)
        return this.getProfile.name.toUpperCase().substring(0,1);
      else if(this.getProfile.preferred_username)
        return this.getProfile.preferred_username.toUpperCase().substring(0,1);
      else
        return "?";
    },
    loggedAs: function() {
      if(this.getProfile.given_name && this.getProfile.family_name)
        return this.getProfile.given_name +" "+ this.getProfile.family_name;
      else if(this.getProfile.name)
        return this.getProfile.name;
      else if(this.getProfile.preferred_username)
        return this.getProfile.preferred_username;
      else
        return "?";
    }
  },

  mounted() {
    this.$store.dispatch(AUTH_REQUEST);
  },
  
  methods: {
    login: function() {
      document.location.href=this.$REST_BASE_URL+"/login"
    },
    logout: function() {
      document.location.href=this.$REST_BASE_URL+"/logout"
    }
  }
  
};

</script>